(* Time-stamp: <modified the 12/12/2012 (at 17:20) by Erwan Jahier> *)

(** Tabulated version of the parse tree.

  - cre  partir de la liste des pack/modeles
  - s'occupe de l'instanciation (purement syntaxique) des modeles
  - cre pour chaque pack provided la liste ``brute'' des noms d'items
  exports. Cette liste sera importante pour traiter les "use" lors de
  la cration des tables de symboles de chaque pack
*)

type t

val create : AstV6.pack_or_model list -> t


(** accs aux infos *)
val pack_body_env : t -> Ident.pack_name -> AstTabSymbol.t

(** A package may have no provided part *)
val pack_prov_env : t -> Ident.pack_name -> Lxm.t -> AstTabSymbol.t option

(** Liste des noms de packs *)
val pack_list : t -> Ident.pack_name list 

(** For debug.  *)
val dump : t -> unit

