(* Time-stamp: <modified the 16/01/2013 (at 17:52) by Erwan Jahier> *)


(** All new identifier names ougth to be created via this module. *)

(** [node_key nk] returns a fresh node ident. 

   The idea is the following: the caller propose a name to map the
   node key. But since that name may clash, we need to work a little bit
   more. This is the purpose of that function.
   
   nb : for a certain node key, it will always return the same string 
   (which means that [name] migth be ignored).
*)
val node_key: Lic.node_key -> string -> string


(** Dealing with fresh local (to the node) variable idents *)

(** Returns a fresh local var name *)
val new_local_var : string -> string (* mv new_var? *)


(**  *)
val array_type : Lic.type_ -> string -> string

(** To be called just after the parsing (to make sure that fresh var names won't clash with 
    user idents. ) *)
val update_fresh_var_prefix : unit -> unit
