(** Time-stamp: <modified the 29/03/2013 (at 16:06) by Erwan Jahier> *)


(** Donne toute les mthodes d'un composant. *)
val get_all_methods: Soc.t -> Soc.step_method list

 
(** Fonctions de reprsentation des objets SOC. *)
val string_of_type_ref            : Soc.var_type -> string
val string_of_soc_key             : Soc.key -> string
val string_of_var                 : Soc.var -> string
val string_of_operation           : Soc.atomic_operation -> string
val string_of_gao                 : Soc.gao -> string
val string_of_gaos_list           : Soc.gao list -> string
val string_of_filter              : Soc.var_expr -> string
val string_of_method              : Soc.t -> Soc.step_method -> string
val string_interface_of_method    : Soc.t -> Soc.step_method -> string
val string_of_precedence          : Soc.precedence -> string
val string_of_profile             : Soc.var list * Soc.var list -> string
val string_interface_of_soc       : Soc.t -> string
val string_of_soc                 : Soc.t -> string

val string_of_type_ref_ff         : Soc.var_type       -> Format.formatter -> unit
val string_of_soc_key_ff          : Soc.key  -> Format.formatter -> unit
val string_of_var_ff              : Soc.var            -> Format.formatter -> unit
val string_of_operation_ff        : Soc.atomic_operation      -> Format.formatter -> unit
val string_of_filter_ff           : Soc.var_expr         -> Format.formatter -> unit
val string_of_gao_ff              : Soc.gao           -> Format.formatter -> unit
val string_of_method_ff           : Soc.t      -> Soc.step_method -> Format.formatter -> unit
val string_interface_of_method_ff : Soc.t      -> Soc.step_method -> Format.formatter -> unit
val string_of_precedence_ff       : string * string list   -> Format.formatter -> unit
val string_of_profile_ff          : Soc.var list * Soc.var list    -> Format.formatter -> unit
val string_interface_of_soc_ff    : Soc.t           -> Format.formatter -> unit
val string_of_soc_ff              : Soc.t              -> Format.formatter -> unit


(** [output header_flag pack_name] dumps the soc list into a
    file. [header_flag] states whether or not headers (comment)
    should be printed *)
val output: bool -> string -> Soc.t list -> unit

(* Raise a compile error in not found *)
val find : Lxm.t -> Soc.key -> Soc.tbl -> Soc.t

(* Raise an internal error if not found *)
val find_no_exc : Soc.key -> Soc.tbl -> Soc.t

(* gen_index_list 5 = [0;1;2;3;4] *)
val gen_index_list : int -> int list
