(** This module contains various tools used thorough the compiler. *)

(** [topolocical_sort printer l dep_fun] does a topological sort on
    the list [l], using the function [f] to find dependency in some
    user-specific structure for each elements of [l], and recursively
    for each dependencies found.
    
    The dependency structure is unknown to this function, since [dep_fun] is
    the interface between each other.
    
    Throws a DependencyCycle exception a if cyclic dependency is found. *)
val f : ('a -> string) -> 'a list -> ('a -> 'a list) -> 'a list

exception DependencyCycle of string * string list
